> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# List Customers

GET https://api.bigcommerce.com/stores/{store_hash}/v2/customers

Returns a list of all *Customers*. Default sorting is by `customer_ID`, from lowest to highest. Optional parameters can be passed in.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/customers/v2/get-customers

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Customers | modify | `store_v2_customers` | | Customers | read-only | `store_v2_customers_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Query parameters

- `first_name` (string, optional) — Filter customers by first name.
- `last_name` (string, optional) — Filter customers by last name.
- `company` (string, optional) — Filter customers by company name.
- `email` (string, optional) — Filter customers by email address.
- `phone` (string, optional) — Filter customers by phone number.
- `store_credit` (string, optional) — Filter customers by store credit amount.
- `customer_group_id` (integer, optional) — Filter customers by customer group ID.
- `min_id` (integer, optional) — Filter results to those with an ID greater than or equal to this value.
- `max_id` (integer, optional) — Filter results to those with an ID less than or equal to this value.
- `min_date_created` (string, optional) — Filter results to those created on or after this date.
- `max_date_created` (string, optional) — Filter results to those created on or before this date.
- `min_date_modified` (string, optional) — Filter results to those modified on or after this date.
- `max_date_modified` (string, optional) — Filter results to those modified on or before this date.
- `tax_exempt_category` (string, optional) — Filter customers by tax exempt category code.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

## Response

### 200

OK

- `list of customer_Full`

## Types

### customer_Full

- `email` (string, required) — Email address of the customer.
- `first_name` (string, required) — First name of the customer.
- `last_name` (string, required) — Last name of the customer.
- `_authentication` (CustomerBaseAuthentication, optional) — Not returned in any responses, but accepts up to two fields allowing you to set the customer’s password. If a password is not supplied, it is generated automatically. For further information about using this object, please see the Customers resource documentation.
- `accepts_marketing` (boolean, optional) — Describes whether the customer accepts product review emails or abandon cart emails. Read-Only.
- `addresses` (CustomerBaseAddresses, optional)
- `company` (string, optional) — The name of the company for which the customer works.
- `customer_group_id` (integer, optional) — The group to which the customer belongs.
- `date_created` (string, optional) — Date on which the customer registered from the storefront or was created in the control panel. This is a Read-Only field; do not set or modify its value in a POST or PUT request.
- `date_modified` (string, optional) — Date on which the customer updated their details in the storefront or was updated in the control panel. This is a Read-Only field; do not set or modify its value in a POST or PUT request.
- `form_fields` (list of CustomerBaseFormFieldsItems, optional, nullable) — Array of custom fields. This is a Read-Only field; do not set or modify its value in a POST or PUT request.
- `id` (integer, optional) — Unique numeric ID of this customer. This is a Read-Only field; do not set or modify its value in a POST or PUT request.
- `notes` (string, optional) — Store-owner notes on the customer.
- `phone` (string, optional) — Phone number of the customer.
- `registration_ip_address` (string, optional) — The customer’s IP address when they signed up.
- `reset_pass_on_login` (boolean, optional) — Force a password change on next login.
- `store_credit` (string, optional) — The amount of credit the customer has. (Float, Float as String, Integer)
- `tax_exempt_category` (string, optional) — If applicable, the tax-exempt category of the shopper’s customer account. You can apply a tax-exempt category to multiple customers. This code should match the exemption codes provided by the third-party integration.

### CustomerBaseAuthentication

Not returned in any responses, but accepts up to two fields allowing you to set the customer’s password. If a password is not supplied, it is generated automatically. For further information about using this object, please see the Customers resource documentation.

- `force_reset` (boolean, optional)
- `password` (string, optional)
- `password_confirmation` (string, optional)

### CustomerBaseAddresses

- `url` (string, optional) — Full URL of where the resource is located.
- `resource` (string, optional) — Resource being accessed.

### CustomerBaseFormFieldsItems

- `name` (string, optional) — Name of the form field.
- `value` (string, optional, nullable) — Value of the form field.

## Examples

**Response**

```json
[
  {
    "email": "janedoe@example.com",
    "first_name": "Jane",
    "last_name": "Doe",
    "_authentication": {
      "force_reset": true,
      "password": "string",
      "password_confirmation": "string"
    },
    "accepts_marketing": true,
    "addresses": {
      "url": "https://api.bigcommerce.com/stores/{store_hash}/v2/customers/5/addresses",
      "resource": "/customers/5/addresses"
    },
    "company": "BigCommerce",
    "customer_group_id": 2,
    "date_created": "string",
    "date_modified": "string",
    "form_fields": [
      {
        "name": "License ID",
        "value": "string"
      }
    ],
    "id": 1,
    "notes": "string",
    "phone": "1234567890",
    "registration_ip_address": "12.345.678.910",
    "reset_pass_on_login": false,
    "store_credit": "0",
    "tax_exempt_category": "string"
  }
]
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v2/customers"

headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>"
}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v2/customers';
const options = {
  method: 'GET',
  headers: {Accept: 'application/json', 'X-Auth-Token': '<apiKey>'}
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v2/customers"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v2/customers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.bigcommerce.com/stores/store_hash/v2/customers")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.bigcommerce.com/stores/store_hash/v2/customers', [
  'headers' => [
    'Accept' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v2/customers");
var request = new RestRequest(Method.GET);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v2/customers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```